--********************************************************************************************
-- FACE_MAKER
--********************************************************************************************
-- Plugin Script
-- Created on 14 12 2003
-- Modified on 23 01 2004
-- Author :   Bruce Forel bruce.forel@laposte.net
-- Purpose : Face_maker allows the user to quicky create a human face primitive
-- Version : v_1.01
--********************************************************************************************
-- MODIFY AT YOUR OWN RISK
--********************************************************************************************
-- Visit http://www.3dvf.com
--********************************************************************************************
--PLEASE FORGIVE ME FOR THE ENGLISH MISTAKES IN COMMENTS

if HeapSize < 15000000 do HeapSize += 10000000
FileIn "FM_Data.dat"

-- FM_Data.dat is a big file holds all morph targets.
-- I ensure to dispose of enough memory before the filein.

Global ItemList = for i = 1 to ((GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" "Nombre") as integer) collect
(
	if (GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" (i as String + "a")) == "1" then
	(
		GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" (i as string)
	)
	else DontCollect
)
--Itemlist is initialized here, it holds all the presets stored in face_maker.ini in order to display them in the presets listbox
Global OkPressed = 0
--OkPressed can adopt 3 values: zero, one and two. Zero: save doesn't happen. One : save happens. Two : Save happens with overwritting

--Saverll is called when the save button is pressed. Saverll allows the users to give a name to the actual settings of face maker and to store them in face_maker.ini
--the store process is called in UtilRll depending on the okpressed value returned by saverll
rollout SaveRll "Save settings" width:250 height:70
(
	EditText SaveNameEdt "Name : " text:"New_Face" pos:[10,15] Fieldwidth:190
	Button OKBtn "OK" pos:[50,45] width:60 height:20
	Button CancelBtn "Cancel" pos:[140,45] width:60 height:20
	
	on CancelBtn pressed do
	(
		OkPressed = 0--save doesn't happen
		DestroyDialog SaveRll
	)
	on OKBtn pressed do
	(
		if SaveNameEdt.text == "" then--the name string must have at least one character
		(
			MessageBox "This is not a valid name." title:"Face_Maker" beep:false
		)
		else
		(
			Local OkToGo = True
			Local Exist = False
			--the following loop ensure the name entered doesn't exist already. If yes, the overwrite dialog box appears
			for num = 1 to ((GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" "Nombre")as integer) do
			(
				if (GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" (num as string)) == SaveNameEdt.text and (GetIniSetting "$plugcfg\\Face_Maker.ini" "ItemList" (num as string + "a")) == "1" do
				(
					Exist = True
				)
			)
			if Exist == true do
			(
				Local Question = "Settings '" + SaveNameEdt.text + "' already exist. \nDo you want to replace them ?"
				if (QueryBox Question Title:"Face_Maker") == true then
				(
					OkPressed = 2--Save and overwrite
					OkToGo = False--oktogo must be false in order to avoid the next "if" condition
					DestroyDialog SaveRll
				)
				else
				(
					OkToGo = False
				)
			)
			if OkToGo == True do
			(
				OkPressed = 1--save new parameters
				DestroyDialog SaveRll
			)
		)
	)
)

ClearListener()-- cleaning the listener

plugin simpleObject Face_Maker
	name:"Face_Maker"
	classID:#(0xd99c57dd, 0x87df94ae)
	category:"Scripted Primitives"
	(
		Local oldTime
		Local Facteur = 0.0					--Facteur is called when a resize happens. Facteur is multiplied to all morph targets arrays to scale them properly
		Local OldTaille = 0.001				--OldTaille holds the size before a resize. size/oldtaille = facteur
		Local WichControl = 0				--WichControl describes wich parameter is being modified. It preserves the CPU from calculating all morph targets when only one parameter is modified
		Local FirstLaunch = true			--FirstLaunch is useful to initialize some parameters...
		Local IsCopy = true					--IsCopy is called when a face_maker instance is copied, loaded or fetched. An event called in buildmesh rebuilds all arrays when iscopy is true
		Local MorphArray = #()				--MorphArray holds the addition of all weighted morph targets stored in the arrays below
		Local RondeurArray = #(); 		Local LongueurArray = #();		Local LargeurArray = #();			Local FrontTailleArray = #();		Local FrontAngleArray = #();	Local FrontPosYArray = #();		Local FrontPosZArray = #(); 	Local JouesOsArray = #();		Local JouesGrosArray = #();		Local MachAngleArray = #();
		Local MachFormeArray = #();		Local MachTailleArray = #();	Local MentonTailleArray = #();		Local MentonGrosArray = #();		Local DoubleMentonArray = #();	Local NuqueTailleArray = #();	Local NuqueMusArray = #();		Local YeuxPosXArray = #();		Local YeuxTailleArray = #();	Local CernesGaucheArray = #();
		Local CernesDroiteArray = #();	Local YeuxCoinsArray = #();		Local YeuxFronceArray = #();		Local PaupiereArray = #();		Local NezPosYArray = #();		Local NezPosZArray = #();		Local NezAreteArray = #();		Local NezBosseArray = #();		Local NezAngleArray = #();		Local NezLargeurArray = #();
		Local NezExTailleArray = #();	Local NezExHauteurArray = #();	Local NezExLargeurArray = #();		Local NarinesLargeurArray = #();	Local NarinesHauteurArray = #();	Local BoucheLargeurArray = #();	Local BouchePosYArray = #();	Local BouchePosZArray = #();	Local LevreHautPosYArray = #();	Local LevreHautEpaisArray = #();
		Local LevreBasPosYArray = #();	Local LevreBasEpaisArray = #();	Local OreillesPosXArray = #();		Local OreillesPosYArray = #(); 	Local OreillesPosZArray = #();	Local OreillesTailleArray = #();	Local OreillesAngleArray = #()

--********************************************************************************************
--** FUNCTION DEFINITION **
--********************************************************************************************
		--this function identifies if facemaker has just been copied, loaded or fetched. If yes, all arrays are emptied by max. I must rebuild them
		--the rebuild happens in the buildmesh event
		Function AmIaCopy =
		(
			Local Holder = (MorphArray.count == 0)
			return Holder
		)

--********************************************************************************************
--** PARAMETERS DEFINITION **
--********************************************************************************************

		parameters GenParam rollout:GenRll
		(
			GenreRdBtn type:#radioBtnIndex ui:GenreRdBtn animatable:false default:1
			Size type:#float ui:TailleSpn animatable:true default:0.001
			Smooth type:#boolean ui:SmoothChk animatable:false default:true
			Coord_Map type:#boolean ui:CoordChk animatable:false default:false
					
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON GENPARAM --
			----------------------------------------------------------------------------------
			
			on Size Set Val do (WichControl = -1; Facteur = Val / OldTaille) --if a resize happens, the division of the size by the old size gives me the resize factor (facteur variable)
			on GenreRdBtn Set Val do WichControl = 0
			on Smooth Set Val do WichControl = undefined
			On Coord_Map Set Val do WichControl = undefined
		)
		
		parameters TeteHautParam rollout:TeteHautRll
		(
			Roundness type:#float ui:(GenRondSpn,GenRondSld) animatable:true default:0
			Length type:#float ui:(GenLongSpn,GenLongSld) animatable:true default:0
			Width type:#float ui:(GenLargSpn,GenLargSld) animatable:true default:0

			ForeHeadSize type:#float ui:(FrontTailleSpn,FrontTailleSld) animatable:true default:0
			ForeHeadAngle type:#float ui:(FrontAngleSpn,FrontAngleSld) animatable:true default:0
			ForeHeadPosY type:#float ui:(FrontPosYSpn,FrontPosYSld) animatable:true default:0
			ForeHeadPosZ type:#float ui:(FrontPosZSpn,FrontPosZSld) animatable:true default:0
					
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON TETEHAUTPARAM --
			----------------------------------------------------------------------------------
			
			on Roundness Set Val do WichControl = 1 --each parameter calls a unique value for wichcontrol
			on Length Set Val do WichControl = 2
			on Width Set Val do WichControl = 3
			
			on ForeHeadSize Set Val do WichControl = 4
			on ForeHeadAngle Set Val do WichControl = 5
			on ForeHeadPosY Set Val do WichControl = 6
			on ForeHeadPosZ Set Val do WichControl = 7
			
		)-- END OF TETEHAUTPARAM
		
		parameters TeteBasParam rollout:TeteBasRll
		(
			CheeksBone type:#float ui:(JouesOsSpn,JouesOsSld) animatable:true default:0
			CheeksFat type:#float ui:(JouesGrosSpn,JouesGrosSld) animatable:true default:0
			
			JawAngle type:#float ui:(MachAngleSpn,MachAngleSld) animatable:true default:0
			JawShape type:#float ui:(MachFormSpn,MachFormSld) animatable:true default:0
			JawSize type:#float ui:(MachTailleSpn,MachTailleSld) animatable:true default:0

			ChinSize type:#float ui:(MentonTailleSpn,MentonTailleSld) animatable:true default:0
			ChinFat type:#float ui:(MentonGrosSpn,MentonGrosSld) animatable:true default:0
			DoubleChin type:#float ui:(MentonDoubleSpn,MentonDoubleSld) animatable:true default:0
			
			NeckSize type:#float ui:(NuquetailleSpn,NuquetailleSld) animatable:true default:0
			NeckMuscles type:#float ui:(NuqueMuscleSpn,NuqueMuscleSld) animatable:true default:0
			
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON TETEBASPARAM --
			----------------------------------------------------------------------------------
			
			on CheeksBone Set Val do WichControl = 8
			on CheeksFat Set Val do WichControl = 9
			
			on JawAngle Set Val do WichControl = 10
			on JawShape Set Val do WichControl = 11
			on JawSize Set Val do WichControl = 12
			
			on ChinSize Set Val do WichControl = 13
			on ChinFat Set Val do WichControl = 14
			on DoubleChin Set Val do WichControl = 15
			
			on NeckSize Set Val do WichControl = 16
			on NeckMuscles Set Val do WichControl = 17
			
		)-- END OF TETEBASPARAM
		
		parameters YeuxParam rollout:YeuxRll
		(
			EyesPosX type:#float ui:(YeuxPosxSpn,YeuxPosxSld) animatable:true default:0
			EyesSize type:#float ui:(YeuxTailleSpn,YeuxTailleSld) animatable:true default:0
			
			BulgeLeftEye type:#float ui:(CernesGaucheSpn,CernesGaucheSld) animatable:true default:0
			BulgeRightEye type:#float ui:(CernesDroiteSpn,CernesDroiteSld) animatable:true default:0

			EyesCorners type:#float ui:(YeuxCoinsSpn,YeuxCoinsSld) animatable:true default:0
			EyesSquarness type:#float ui:(YeuxFronceSpn,YeuxFronceSld) animatable:true default:0
			EyeLid type:#float ui:(YeuxPaupiereSpn,YeuxPaupiereSld) animatable:true default:0
			
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON YEUXPARAM --
			----------------------------------------------------------------------------------
			
			on EyesPosX Set Val do WichControl = 18
			on EyesSize Set Val do WichControl = 19
			
			on BulgeLeftEye Set Val do WichControl = 20
			on BulgeRightEye Set Val do WichControl = 21
			
			on EyesCorners Set Val do WichControl = 22
			on EyesSquarness Set Val do WichControl = 23
			on EyeLid Set Val do WichControl = 24
			
		)-- END OF YEUXPARAM
		
		parameters NezParam rollout:NezRll
		(
			NosePosY type:#float ui:(NezPosySpn,NezPosySld) animatable:true default:0
			NosePosZ type:#float ui:(NezPoszSpn,NezPoszSld) animatable:true default:0
			
			NoseEdge type:#float ui:(NezAreteSpn,NezAreteSld) animatable:true default:0
			NoseBump type:#float ui:(NezBosseSpn,NezBosseSld) animatable:true default:0
			NoseAngle type:#float ui:(NezAngleSpn,NezAngleSld) animatable:true default:0
			NoseWidth type:#float ui:(NezLargeurSpn,NezLargeurSld) animatable:true default:0

			NoseTipSize type:#float ui:(NezExTailleSpn,NezExTailleSld) animatable:true default:0
			NoseTipHeight type:#float ui:(NezExHauteurSpn,NezExHauteurSld) animatable:true default:0
			NoseTipWidth type:#float ui:(NezExLargeurSpn,NezExLargeurSld) animatable:true default:0
			
			NostrilsWidth type:#float ui:(NarinesLargeurSpn,NarinesLargeurSld) animatable:true default:0
			NostrilsHeight type:#float ui:(NarinesHauteurSpn,NarinesHauteurSld) animatable:true default:0
			
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON NEZPARAM --
			----------------------------------------------------------------------------------
			
			on NosePosY Set Val do WichControl = 25
			on NosePosZ Set Val do WichControl = 26
			
			on NoseEdge Set Val do WichControl = 27
			on NoseBump Set Val do WichControl = 28
			on NoseAngle Set Val do WichControl = 29
			on NoseWidth Set Val do WichControl = 30
			
			on NoseTipSize Set Val do WichControl = 31
			on NoseTipHeight Set Val do WichControl = 32
			on NoseTipWidth Set Val do WichControl = 33
			
			on NostrilsWidth Set Val do WichControl = 34
			on NostrilsHeight Set Val do WichControl = 35
			
		)-- END OF NEZPARAM
		
		parameters BoucheParam rollout:BoucheRll
		(
			MouthWidth type:#float ui:(BoucheLargeurSpn,BoucheLargeurSld) animatable:true default:0
			MouthPosY type:#float ui:(BouchePosySpn,BouchePosySld) animatable:true default:0
			MouthPosZ type:#float ui:(BouchePoszSpn,BouchePoszSld) animatable:true default:0
			
			UpperLipPosY type:#float ui:(LevreHautPosYSpn,LevreHautPosYSld) animatable:true default:0
			UpperLipThickness type:#float ui:(LevreHautEpaisSpn,LevreHautEpaisSld) animatable:true default:0

			LowerLipPosY type:#float ui:(LevreBasPosYSpn,LevreBasPosYSld) animatable:true default:0
			LowerLipThickness type:#float ui:(LevreBasEpaisSpn,LevreBasEpaisSld) animatable:true default:0
			
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON BOUCHEPARAM --
			----------------------------------------------------------------------------------
			
			on MouthWidth Set Val do WichControl = 36
			on MouthPosY Set Val do WichControl = 37
			on MouthPosZ Set Val do WichControl = 38
			
			on UpperLipPosY Set Val do WichControl = 39
			on UpperLipThickness Set Val do WichControl = 40
			
			on LowerLipPosY Set Val do WichControl = 41
			on LowerLipThickness Set Val do WichControl = 42
			
		)-- END OF BOUCHEPARAM
		
		parameters OreilleParam rollout:OreilleRll
		(
			EarsPosX type:#float ui:(OreillePosxSpn,OreillePosxSld) animatable:true default:0
			EarsPosY type:#float ui:(OreillePosySpn,OreillePosySld) animatable:true default:0
			EarsPosZ type:#float ui:(OreillePoszSpn,OreillePoszSld) animatable:true default:0
			
			EarsSize type:#float ui:(OreilleTailleSpn,OreilleTailleSld) animatable:true default:0
			EarsAngle type:#float ui:(OreilleAngleSpn,OreilleAngleSld) animatable:true default:0
			
			----------------------------------------------------------------------------------
			-- EVENT HANDLER ON OREILLEPARAM --
			----------------------------------------------------------------------------------
			
			on EarsPosX Set Val do WichControl = 43
			on EarsPosY Set Val do WichControl = 44
			on EarsPosZ Set Val do WichControl = 45
			
			on EarsSize Set Val do WichControl = 46
			on EarsAngle Set Val do WichControl = 47
			
		)-- END OF OREILLEPARAM

--********************************************************************************************
--** ROLLOUTS DEFINITION **
--********************************************************************************************
		
		rollout GenRll "Properties"
		(
			group "Gender"
			(
				radiobuttons GenreRdBtn labels:#("Man   ","Woman") default:1
			)
			spinner TailleSpn "Size : " range:[0.001,10000,0.001] pos:[5,52] type:#float fieldwidth:60
			Checkbox SmoothChk "Smooth" checked:true pos:[5,70]
			Checkbox CoordChk "Generate Coord_Map" checked:false pos:[5,90]
		)-- END OF GENRLL

		rollout TeteHautRll "Head / Forehead"
		(
			Group "General"
			(
				spinner GenRondSpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider GenRondSld "  Roundness : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner GenLongSpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider GenLongSld "  Length : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner GenLargSpn "" pos:[96,120] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider GenLargSld "  Width : " pos:[8,104] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Forehead"
			(
				spinner FrontTailleSpn "" pos:[96,192] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider FrontTailleSld "  Size : " pos:[8,176] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner FrontAngleSpn "" pos:[96,232] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider FrontAngleSld "  Angle : " pos:[8,216] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner FrontPosySpn "" pos:[96,272] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider FrontPosySld "  Position Y : " pos:[8,256] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner FrontPoszSpn "" pos:[96,312] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider FrontPoszSld "  Position Z : " pos:[8,296] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)--END OF TETEHAUTRLL
	
		rollout TeteBasRll "Head / Lower"
		(
			Group "Cheeks"
			(
				spinner JouesOsSpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider JouesOsSld "  Bone : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner JouesGrosSpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider JouesGrosSld "  Fat : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Jaw"
			(
				spinner MachAngleSpn "" pos:[96,152] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MachAngleSld "  Angle : " pos:[8,136] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner MachFormSpn "" pos:[96,192] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MachFormSld "  Shape : " pos:[8,176] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner MachTailleSpn "" pos:[96,232] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MachTailleSld "  Size : " pos:[8,216] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Chin"
			(
				spinner MentonTailleSpn "" pos:[96,304] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MentonTailleSld "  Size : " pos:[8,288] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner MentonGrosSpn "" pos:[96,344] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MentonGrosSld "  Fat : " pos:[8,328] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner MentonDoubleSpn "" pos:[96,384] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider MentonDoubleSld "  Double chin : " pos:[8,368] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Neck"
			(
				spinner NuqueTailleSpn "" pos:[96,456] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NuqueTailleSld "  Size : " pos:[8,440] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NuqueMuscleSpn "" pos:[96,496] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NuqueMuscleSld "  Muscles : " pos:[8,480] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)--END OF TETEBASRLL
		
		rollout YeuxRll "Eyes"
		(
			Group "Position and Size"
			(
				spinner YeuxPosxSpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider YeuxPosxSld "  Position X : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner YeuxTailleSpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider YeuxTailleSld "  Size : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Bulge"
			(
				spinner CernesGaucheSpn "" pos:[96,152] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider CernesGaucheSld "  Left Eye : " pos:[8,136] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner CernesDroiteSpn "" pos:[96,192] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider CernesDroiteSld "  Right Eye : " pos:[8,176] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Shape"
			(
				spinner YeuxCoinsSpn "" pos:[96,264] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider YeuxCoinsSld "  Corners : " pos:[8,248] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner YeuxFronceSpn "" pos:[96,304] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider YeuxFronceSld "  Squarness : " pos:[8,288] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner YeuxPaupiereSpn "" pos:[96,344] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider YeuxPaupiereSld "  Lower Eyelid : " pos:[8,328] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)-- END OF YEUXRLL
		
		rollout NezRll "Nose"
		(
			Group "Position"
			(
				spinner NezPosySpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezPosySld "  Position Y : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezPoszSpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezPoszSld "  Position Z : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Shape"
			(
				spinner NezAreteSpn "" pos:[96,152] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezAreteSld "  Edge : " pos:[8,136] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezBosseSpn "" pos:[96,192] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezBosseSld "  Bump : " pos:[8,176] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezAngleSpn "" pos:[96,232] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezAngleSld "  Angle : " pos:[8,216] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezLargeurSpn "" pos:[96,272] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezLargeurSld "  Width : " pos:[8,256] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Tip"
			(
				spinner NezExTailleSpn "" pos:[96,344] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezExTailleSld "  Size : " pos:[8,328] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezExHauteurSpn "" pos:[96,384] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezExHauteurSld "  Height : " pos:[8,368] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NezExLargeurSpn "" pos:[96,424] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NezExLargeurSld "  Width : " pos:[8,408] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Nostrils"
			(
				spinner NarinesLargeurSpn "" pos:[96,496] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NarinesLargeurSld "  Width : " pos:[8,480] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner NarinesHauteurSpn "" pos:[96,536] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider NarinesHauteurSld "  Height : " pos:[8,520] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)-- END OF NEZRLL
		
		rollout BoucheRll "Mouth"
		(	
			Group "Position and Size"
			(
				spinner BoucheLargeurSpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider BoucheLargeurSld "  Width : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner BouchePosySpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider BouchePosySld "  Position Y : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner BouchePoszSpn "" pos:[96,120] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider BouchePoszSld "  Position Z : " pos:[8,104] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Upper Lip"
			(
				spinner LevreHautPosYSpn "" pos:[96,187] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider LevreHautPosYSld "  Position Y : " pos:[8,168] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner LevreHautEpaisSpn "" pos:[96,227] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider LevreHautEpaisSld "  Thickness : " pos:[8,211] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Lower Lip"
			(
				spinner LevreBasPosYSpn "" pos:[96,296] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider LevreBasPosYSld "  Position Y : " pos:[8,280] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner LevreBasEpaisSpn "" pos:[96,336] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider LevreBasEpaisSld "  Thickness : " pos:[8,320] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)-- END OF BOUCHERLL
		
		rollout OreilleRll "Ears"
		(
			Group "Position"
			(
				spinner OreillePosxSpn "" pos:[96,40] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider OreillePosxSld "  Position X : " pos:[8,24] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner OreillePosySpn "" pos:[96,80] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider OreillePosySld "  Position Y : " pos:[8,64] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner OreillePoszSpn "" pos:[96,120] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider OreillePoszSld "  Position Z : " pos:[8,104] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
			
			Group "Shape"
			(
				spinner OreilleTailleSpn "" pos:[96,187] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider OreilleTailleSld "  Size : " pos:[8,168] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
				spinner OreilleAngleSpn "" pos:[96,227] width:50 height:16 enabled:true range:[-1,1,0] type:#float scale:0.001
				slider OreilleAngleSld "  Angle : " pos:[8,211] width:90 height:44 range:[-1,1,0] type:#float orient:#horizontal ticks:0
			)
		)-- END OF OREILLERLL
		
		rollout UtilRll "Save and Load"
		(
			group "Presets"
			(
				ListBox Lbx "" items:ItemList
				Button SaveBtn "Save" pos:[15,170] width:60 height:20
				Button LoadBtn "Load" pos:[88,170] width:60 height:20
				Button DelBtn "Delete" align:#center width:134 height:20
				Button ResetBtn "Reset" align:#center width:134 height:20
			)
			Label lbl1 "Face_Maker Plugin Script"
			Label lbl2 "Version v_1.01"
			Label lbl3 "bruce.forel@laposte.net"
			
			--********************************************************************************************
			--**  EVENT HANDLER ON UTILRLL **
			--********************************************************************************************
			
			--this event is implemented for comfort. you just have to doubleclik an item on the listbox to make it loaded. the process is the same as loadbtn event
			on Lbx DoubleClicked Elts do
			(
				With redraw off
				(
					Local index = 1
					--I review all parameters stored in face_maker.ini and I load them with the getinisetting command
					This.GenRll.Controls[2].state = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected "Genre") as integer
					For UIitems = 1 to This.TeteHautRll.Controls.count do
					(
						if This.TeteHautRll.Controls[UIitems].caption == "" do (this.TeteHautRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.TeteBasRll.Controls.count do
					(
						if This.TeteBasRll.Controls[UIitems].caption == "" do (this.TeteBasRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.YeuxRll.Controls.count do
					(
						if This.YeuxRll.Controls[UIitems].caption == "" do (this.YeuxRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.NezRll.Controls.count do
					(
						if This.NezRll.Controls[UIitems].caption == "" do (this.NezRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.BoucheRll.Controls.count do
					(
						if This.BoucheRll.Controls[UIitems].caption == "" do (this.BoucheRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.OreilleRll.Controls.count do
					(
						if This.OreilleRll.Controls[UIitems].caption == "" do (this.OreilleRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
				)
				This.GenRll.Controls[2].state = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected "Genre") as integer
			)
			on SaveBtn pressed do
			(
				--Saverll is called here. The saverll rollout definition is made at the beginning of the script
				CreateDialog SaveRll width:250 height:70 style:#(#style_border) modal:true --delete "modal:true" to make the plugin work with max4
				--Saverll can return 3 values 
				case OkPressed of
				(
					0:--no save, cancel button is pressed
					(
						OkPressed = false
					)
					1:--new save
					(
						Local Nombre = (GetIniSetting "$plugcfg\\face_maker.ini" "ItemList" "Nombre") as integer
						Local index = 1
						--i store all the currents face maker parameters in a new file in face_maker.ini
						SetIniSetting "$plugcfg\\face_maker.ini" "ItemList" "nombre" ((Nombre + 1) as string)
						SetIniSetting "$plugcfg\\face_maker.ini" "ItemList" ((Nombre + 1) as string) SaveRll.SaveNameEdt.text
						SetIniSetting "$plugcfg\\face_maker.ini" "ItemList" ((Nombre + 1) as string + "a") "1"
						SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text "Genre" ((This.GenRll.Controls[2].state) as string)
						
						For UIitems = 1 to This.TeteHautRll.Controls.count do
						(
							if This.TeteHautRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.TeteHautRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.TeteBasRll.Controls.count do
						(
							if This.TeteBasRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.TeteBasRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.YeuxRll.Controls.count do
						(
							if This.YeuxRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.YeuxRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.NezRll.Controls.count do
						(
							if This.NezRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.NezRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.BoucheRll.Controls.count do
						(
							if This.BoucheRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.BoucheRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.OreilleRll.Controls.count do
						(
							if This.OreilleRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.OreilleRll.Controls[UIitems].value as string); index += 1)
						)
						--then i rebuild the listbox itemlist
						Append ItemList SaveRll.SaveNameEdt.text
						Lbx.items = ItemList
						OkPressed = false
					)
					2:--save with overwritting
					(
						Local index = 1
						
						SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text "Genre" ((This.GenRll.Controls[2].state) as string)
						
						For UIitems = 1 to This.TeteHautRll.Controls.count do
						(
							if This.TeteHautRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.TeteHautRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.TeteBasRll.Controls.count do
						(
							if This.TeteBasRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.TeteBasRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.YeuxRll.Controls.count do
						(
							if This.YeuxRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.YeuxRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.NezRll.Controls.count do
						(
							if This.NezRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.NezRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.BoucheRll.Controls.count do
						(
							if This.BoucheRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.BoucheRll.Controls[UIitems].value as string); index += 1)
						)
						For UIitems = 1 to This.OreilleRll.Controls.count do
						(
							if This.OreilleRll.Controls[UIitems].caption == "" do (SetIniSetting "$plugcfg\\face_maker.ini" SaveRll.SaveNameEdt.text (index as string) (This.OreilleRll.Controls[UIitems].value as string); index += 1)
						)
						OkPressed = false
					)
				)
			)
			
			on LoadBtn pressed do
			(
				With redraw off
				if Lbx.Selected != undefined do
				(
					--DisableSceneRedraw()
					Local index = 1
					This.GenRll.Controls[2].state = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected "Genre") as integer
					For UIitems = 1 to This.TeteHautRll.Controls.count do
					(
						if This.TeteHautRll.Controls[UIitems].caption == "" do (this.TeteHautRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.TeteBasRll.Controls.count do
					(
						if This.TeteBasRll.Controls[UIitems].caption == "" do (this.TeteBasRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.YeuxRll.Controls.count do
					(
						if This.YeuxRll.Controls[UIitems].caption == "" do (this.YeuxRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.NezRll.Controls.count do
					(
						if This.NezRll.Controls[UIitems].caption == "" do (this.NezRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.BoucheRll.Controls.count do
					(
						if This.BoucheRll.Controls[UIitems].caption == "" do (this.BoucheRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
					For UIitems = 1 to This.OreilleRll.Controls.count do
					(
						if This.OreilleRll.Controls[UIitems].caption == "" do (this.OreilleRll.controls[UIitems].value = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected (index as string)) as float; index += 1)
					)
				)
				This.GenRll.Controls[2].state = (GetIniSetting "$Plugcfg\\Face_Maker.ini" Lbx.Selected "Genre") as integer
			)
			
			on DelBtn pressed do--the selected presets are deleted
			(
				if Lbx.Selected != undefined do
				(
					--the querybox ensure the button was not pressed by accident (hum)
					if (QueryBox ("Are you sure you want to delete '" + Lbx.Selected + "' ?\nThis operation can't be undone.") Title:"Face_Maker") == True do
					(
						For i = 1 to ((GetIniSetting "$plugcfg\\face_maker.ini" "ItemList" "Nombre")as integer) do
						(
							if (GetIniSetting "$plugcfg\\face_maker.ini" "ItemList" (i as string)) == Lbx.Selected do
							(
								SetIniSetting "$plugcfg\\face_maker.ini" "ItemList" (i as string + "a") "0"
							)
						)
						For i = 1 to ItemList.count do
						(
							if ItemList[i] == Lbx.selected do DeleteItem ItemList i
						)
						Lbx.Items = ItemList
					)
				)
			)
			
			on ResetBtn pressed do--all parameters are brought back to zero when the resetbtn is pressed
			(
				With redraw off
				--the querybox ensure the button was not pressed by accident (hum)
				if (QueryBox "Are you sure you want to reset Face_Maker ?\nThis operation can't be undone." title:"Face_Maker") == true do
				(
					--DisableSceneRedraw()
					For UIitems = 1 to This.TeteHautRll.Controls.count do
					(
						if This.TeteHautRll.Controls[UIitems].caption == "" do (this.TeteHautRll.controls[UIitems].value = 0.0)
					)
					For UIitems = 1 to This.TeteBasRll.Controls.count do
					(
						if This.TeteBasRll.Controls[UIitems].caption == "" do (this.TeteBasRll.controls[UIitems].value = 0.0)
					)
					For UIitems = 1 to This.YeuxRll.Controls.count do
					(
						if This.YeuxRll.Controls[UIitems].caption == "" do (this.YeuxRll.controls[UIitems].value = 0.0)
					)
					For UIitems = 1 to This.NezRll.Controls.count do
					(
						if This.NezRll.Controls[UIitems].caption == "" do (this.NezRll.controls[UIitems].value = 0.0)
					)
					For UIitems = 1 to This.BoucheRll.Controls.count do
					(
						if This.BoucheRll.Controls[UIitems].caption == "" do (this.BoucheRll.controls[UIitems].value = 0.0)
					)
					For UIitems = 1 to This.OreilleRll.Controls.count do
					(
						if This.OreilleRll.Controls[UIitems].caption == "" do (this.OreilleRll.controls[UIitems].value = 0.0)
					)
					This.GenRll.Controls[2].state = 1
				)
			)
			
		)-- END OF UTILRLL
		
--********************************************************************************************
--** CONSTRUCTOR **
--********************************************************************************************

		on BuildMesh do
		(
			Local VertPosArray = #() --this array ensure vertarray_x integrity
			if FirstLaunch == true do (WichControl = 0; FirstLaunch = false;) --when firstlaunch happens , wichcontrol must be brought back to 0
			if Size == 0 do Size = 0.001 --size = 0 == script = BOOM
			if oldTime != CurrentTime do WichControl = 0
			--Vertposarray is filled here. It stores the initial vertex position multiplied by the size then divided by 10 for the visual comfort
			if GenreRdBtn == 1 then (For Vertex = 1 to 300 do VertPosArray[Vertex] = VertArray_H[Vertex] * Size / 10) else (For Vertex = 1 to 300 do VertPosArray[Vertex] = VertArray_F[Vertex] * Size / 10)

--****************************************************************************
			SetMesh mesh verts:VertPosArray faces:FaceArray tverts:tv_Array -- mesh is generated here. Tv_array and facearray are stored in fm_data.fat
--****************************************************************************

			--the edge loop find the edges wich must be unvisible and make them become..............unvisible (!)
			For edge = 1 to InvisEdgeArray.count do ( local FaceNum = Ceil (InvisEdgeArray[edge] / 3.0); local EdgeNum = Mod InvisEdgeArray[edge] 3; if EdgeNum == 0.0 then EdgeNum = 3; SetEdgeVis mesh FaceNum EdgeNum False )
			--the smooth condition create or destroy smoothing group
			if Smooth then ( For face = 1 to 564 do SetFaceSmoothGroup mesh face 1 ) else ( For face = 1 to 564 do SetFaceSmoothGroup mesh face 0 )
			--the coord_map condition builds or destroy the mapping coordinates.
			if Coord_Map then (buildtvfaces mesh; for tface = 1 to 564 do SetTvFace mesh tface tf_Array[tface]) else (meshop.MakeMapPlanar mesh 1)
			--the AmIacopy function is called here. If the face_maker instance is a copy (and so all arrays are empty) the iscopy variable helps to identify the problem later in the script
			if AmIaCopy() == True then IsCopy = True else IsCopy = false
			--the wichcontrol condition avoid the script to evaluate ,each time a paramater is modified, the 300 vertex of the 94 morph targets. the script focalize on the parameter being modified. Without wichcontrol, the script works but is too much CPU intensive			
			Case WichControl of
			(
				(-1):--la Size is modified
				(
					For Vertex = 1 to 300 do
					(
						-- facteur is called here to scale all arrays
						if MorphArray[300] != undefined do MorphArray[Vertex] *= Facteur
						
						if LongueurArray[300] != undefined do LongueurArray[Vertex] *= Facteur
						if RondeurArray[300] != undefined do RondeurArray[Vertex] *= Facteur
						if LargeurArray[300] != undefined do LargeurArray[Vertex] *= Facteur
						
						if FrontTailleArray[300] != undefined do FrontTailleArray[Vertex] *= Facteur
						if FrontAngleArray[300] != undefined do FrontAngleArray[Vertex] *= Facteur
						if FrontPosYArray[300] != undefined do FrontPosYArray[Vertex] *= Facteur
						if FrontPosZArray[300] != undefined do FrontPosZArray[Vertex] *= Facteur
						
						if JouesOsArray[300] != undefined do JouesOsArray[Vertex] *= Facteur
						if JouesGrosArray[300] != undefined do JouesGrosArray[Vertex] *= Facteur
						
						if MachAngleArray[300] != undefined  do MachAngleArray[Vertex] *= Facteur
						if MachFormeArray[300] != undefined  do MachFormeArray[Vertex] *= Facteur
						if MachTailleArray[300] != undefined  do MachTailleArray[Vertex] *= Facteur
						
						if MentonGrosArray[300] != undefined  do MentonGrosArray[Vertex] *= Facteur
						if DoubleMentonArray[300] != undefined  do DoubleMentonArray[Vertex] *= Facteur
						if MentonTailleArray[300] != undefined  do MentonTailleArray[Vertex] *= Facteur
						
						if NuqueTailleArray[300] != undefined  do NuqueTailleArray[Vertex] *= Facteur
						if NuqueMusArray[300] != undefined  do NuqueMusArray[Vertex] *= Facteur
						
						if YeuxPosXArray[300] != undefined  do YeuxPosXArray[Vertex] *= Facteur
						if YeuxTailleArray[300] != undefined  do YeuxTailleArray[Vertex] *= Facteur

						if CernesGaucheArray[300] != undefined  do CernesGaucheArray[Vertex] *= Facteur
						if CernesDroiteArray[300] != undefined  do CernesDroiteArray[Vertex] *= Facteur
						
						if YeuxCoinsArray[300] != undefined  do YeuxCoinsArray[Vertex] *= Facteur
						if YeuxFronceArray[300] != undefined  do YeuxFronceArray[Vertex] *= Facteur
						if PaupiereArray[300] != undefined  do PaupiereArray[Vertex] *= Facteur
						
						if NezPosYArray[300] != undefined  do NezPosYArray[Vertex] *= Facteur
						if NezPosZArray[300] != undefined  do NezPosZArray[Vertex] *= Facteur
						
						if NezAreteArray[300] != undefined  do NezAreteArray[Vertex] *= Facteur
						if NezBosseArray[300] != undefined  do NezBosseArray[Vertex] *= Facteur
						if NezAngleArray[300] != undefined  do NezAngleArray[Vertex] *= Facteur
						if NezLargeurArray[300] != undefined  do NezLargeurArray[Vertex] *= Facteur
						
						if NezExTailleArray[300] != undefined  do NezExTailleArray[Vertex] *= Facteur
						if NezExHauteurArray[300] != undefined  do NezExHauteurArray[Vertex] *= Facteur
						if NezExLargeurArray[300] != undefined  do NezExLargeurArray[Vertex] *= Facteur
						
						if NarinesLargeurArray[300] != undefined  do NarinesLargeurArray[Vertex] *= Facteur
						if NarinesHauteurArray[300] != undefined  do NarinesHauteurArray[Vertex] *= Facteur
						
						if BoucheLargeurArray[300] != undefined  do BoucheLargeurArray[Vertex] *= Facteur
						if BouchePosYArray[300] != undefined  do BouchePosYArray[Vertex] *= Facteur
						if BouchePosZArray[300] != undefined  do BouchePosZArray[Vertex] *= Facteur
						
						if LevreHautPosYArray[300] != undefined  do LevreHautPosYArray[Vertex] *= Facteur
						if LevreHautEpaisArray[300] != undefined  do LevreHautEpaisArray[Vertex] *= Facteur
						
						if LevreBasPosYArray[300] != undefined  do LevreBasPosYArray[Vertex] *= Facteur
						if LevreBasEpaisArray[300] != undefined  do LevreBasEpaisArray[Vertex] *= Facteur
						
						if OreillesPosXArray[300] != undefined  do OreillesPosXArray[Vertex] *= Facteur
						if OreillesPosYArray[300] != undefined  do OreillesPosYArray[Vertex] *= Facteur
						if OreillesPosZArray[300] != undefined  do OreillesPosZArray[Vertex] *= Facteur
						
						if OreillesTailleArray[300] != undefined  do OreillesTailleArray[Vertex] *= Facteur
						if OreillesAngleArray[300] != undefined  do OreillesAngleArray[Vertex] *= Facteur
					)
					OldTaille = Size	--after the resize, the new size becomes the old one
				)
				0:--the gender
				(								
					--when gender is toggled, the whole topology is changed. I must rebuild all arrays
					--this operation is quite cpu intensive so a progressbar may be implemented
					For i = 1 to 300 do MorphArray[i] = [0,0,0]
					if Roundness > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Rondeur_H1[Vertex] * (-Roundness * Size / 10)))
					if Roundness < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Rondeur_H0[Vertex] * (Roundness * Size / 10)))
					if Length > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Longueur_H1[Vertex] * (-Length * Size / 10)))
					if Length < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Longueur_H0[Vertex] * (Length * Size / 10)))
					if Width > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Largeur_H1[Vertex] * (-Width * Size / 10)))
					if Width < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Largeur_H0[Vertex] * (Width * Size / 10)))
					
					if ForeHeadSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontTaille_H1[Vertex] * (-ForeHeadSize * Size / 10)))
					if ForeHeadSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontTaille_H0[Vertex] * (ForeHeadSize * Size / 10)))
					if ForeHeadAngle > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontAngle_H1[Vertex] * (-ForeHeadAngle * Size / 10)))
					if ForeHeadAngle < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontAngle_H0[Vertex] * (ForeHeadAngle * Size / 10)))
					if ForeHeadPosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontPosY_H1[Vertex] * (-ForeHeadPosY * Size / 10)))
					if ForeHeadPosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontPosY_H0[Vertex] * (ForeHeadPosY * Size / 10)))
					if ForeHeadPosZ > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontPosZ_H1[Vertex] * (-ForeHeadPosZ * Size / 10)))
					if ForeHeadPosZ < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (FrontPosZ_H0[Vertex] * (ForeHeadPosZ * Size / 10)))
					
					if CheeksBone > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (JouesOs_H1[Vertex] * (-CheeksBone * Size / 10)))
					if CheeksBone < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (JouesOs_H0[Vertex] * (CheeksBone * Size / 10)))
					if CheeksFat > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (JouesGros_H1[Vertex] * (-CheeksFat * Size / 10)))
					if CheeksFat < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (JouesGros_H0[Vertex] * (CheeksFat * Size / 10)))
					
					if JawAngle > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachAngle_H1[Vertex] * (-JawAngle * Size / 10)))
					if JawAngle < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachAngle_H0[Vertex] * (JawAngle * Size / 10)))
					if JawShape > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachForme_H1[Vertex] * (-JawShape * Size / 10)))
					if JawShape < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachForme_H0[Vertex] * (JawShape * Size / 10)))
					if JawSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachTaille_H1[Vertex] * (-JawSize * Size / 10)))
					if JawSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MachTaille_H0[Vertex] * (JawSize * Size / 10)))
					
					if ChinSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MentonTaille_H1[Vertex] * (-ChinSize * Size / 10)))
					if ChinSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MentonTaille_H0[Vertex] * (ChinSize * Size / 10)))
					if ChinFat > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MentonGros_H1[Vertex] * (-ChinFat * Size / 10)))
					if ChinFat < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (MentonGros_H0[Vertex] * (ChinFat * Size / 10)))
					if DoubleChin > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (DoubleMenton_H1[Vertex] * (-DoubleChin * Size / 10)))
					if DoubleChin < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (DoubleMenton_H0[Vertex] * (DoubleChin * Size / 10)))
					
					if NeckSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NuqueTaille_H1[Vertex] * (-NeckSize * Size / 10)))
					if NeckSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NuqueTaille_H0[Vertex] * (NeckSize * Size / 10)))
					if NeckMuscles > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NuqueMus_H1[Vertex] * (-NeckMuscles * Size / 10)))
					if NeckMuscles < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NuqueMus_H0[Vertex] * (NeckMuscles * Size / 10)))
					
					if EyesPosX > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxPosX_H1[Vertex] * (-EyesPosX * Size / 10)))
					if EyesPosX < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxPosX_H0[Vertex] * (EyesPosX * Size / 10)))
					if EyesSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxTaille_H1[Vertex] * (-EyesSize * Size / 10)))
					if EyesSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxTaille_H0[Vertex] * (EyesSize * Size / 10)))
					
					if BulgeLeftEye > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (CernesGauche_H1[Vertex] * (-BulgeLeftEye * Size / 10)))
					if BulgeLeftEye < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (CernesGauche_H0[Vertex] * (BulgeLeftEye * Size / 10)))
					if BulgeRightEye > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (CernesDroite_H1[Vertex] * (-BulgeRightEye * Size / 10)))
					if BulgeRightEye < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (CernesDroite_H0[Vertex] * (BulgeRightEye * Size / 10)))
					
					if EyesCorners > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxCoins_H1[Vertex] * (-EyesCorners * Size / 10)))
					if EyesCorners < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxCoins_H0[Vertex] * (EyesCorners * Size / 10)))
					if EyesSquarness > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxFronce_H1[Vertex] * (-EyesSquarness * Size / 10)))
					if EyesSquarness < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (YeuxFronce_H0[Vertex] * (EyesSquarness * Size / 10)))
					if EyeLid > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Paupiere_H1[Vertex] * (-EyeLid * Size / 10)))
					if EyeLid < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (Paupiere_H0[Vertex] * (EyeLid * Size / 10)))
					
					if NosePosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezPosY_H1[Vertex] * (-NosePosY * Size / 10)))
					if NosePosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezPosY_H0[Vertex] * (NosePosY * Size / 10)))
					if NosePosZ > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezPosZ_H1[Vertex] * (-NosePosZ * Size / 10)))
					if NosePosZ < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezPosZ_H0[Vertex] * (NosePosZ * Size / 10)))
					
					if NoseEdge > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezArete_H1[Vertex] * (-NoseEdge * Size / 10)))
					if NoseEdge < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezArete_H0[Vertex] * (NoseEdge * Size / 10)))
					if NoseBump > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezBosse_H1[Vertex] * (-NoseBump * Size / 10)))
					if NoseBump < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezBosse_H0[Vertex] * (NoseBump * Size / 10)))
					if NoseAngle > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezAngle_H1[Vertex] * (-NoseAngle * Size / 10)))
					if NoseAngle < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezAngle_H0[Vertex] * (NoseAngle * Size / 10)))
					if NoseWidth > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezLargeur_H1[Vertex] * (-NoseWidth * Size / 10)))
					if NoseWidth < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezLargeur_H0[Vertex] * (NoseWidth * Size / 10)))
					
					if NoseTipSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExTaille_H1[Vertex] * (-NoseTipSize * Size / 10)))
					if NoseTipSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExTaille_H0[Vertex] * (NoseTipSize * Size / 10)))
					if NoseTipHeight > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExHauteur_H1[Vertex] * (-NoseTipHeight * Size / 10)))
					if NoseTipHeight < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExHauteur_H0[Vertex] * (NoseTipHeight * Size / 10)))
					if NoseTipWidth > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExLargeur_H1[Vertex] * (-NoseTipWidth * Size / 10)))
					if NoseTipWidth < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NezExLargeur_H0[Vertex] * (NoseTipWidth * Size / 10)))
					
					if NostrilsWidth > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NarinesLargeur_H1[Vertex] * (-NostrilsWidth * Size / 10)))
					if NostrilsWidth < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NarinesLargeur_H0[Vertex] * (NostrilsWidth * Size / 10)))
					if NostrilsHeight > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NarinesHauteur_H1[Vertex] * (-NostrilsHeight * Size / 10)))
					if NostrilsHeight < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (NarinesHauteur_H0[Vertex] * (NostrilsHeight * Size / 10)))
					
					if MouthWidth > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BoucheLargeur_H1[Vertex] * (-MouthWidth * Size / 10)))
					if MouthWidth < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BoucheLargeur_H0[Vertex] * (MouthWidth * Size / 10)))
					if MouthPosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BouchePosY_H1[Vertex] * (-MouthPosY * Size / 10)))
					if MouthPosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BouchePosY_H0[Vertex] * (MouthPosY * Size / 10)))
					if MouthPosZ > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BouchePosZ_H1[Vertex] * (-MouthPosZ * Size / 10)))
					if MouthPosZ < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (BouchePosZ_H0[Vertex] * (MouthPosZ * Size / 10)))
					
					if UpperLipPosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreHautPosY_H1[Vertex] * (-UpperLipPosY * Size / 10)))
					if UpperLipPosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreHautPosY_H0[Vertex] * (UpperLipPosY * Size / 10)))
					if UpperLipThickness > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreHautEpais_H1[Vertex] * (-UpperLipThickness * Size / 10)))
					if UpperLipThickness < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreHautEpais_H0[Vertex] * (UpperLipThickness * Size / 10)))
					
					if LowerLipPosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreBasPosY_H1[Vertex] * (-LowerLipPosY * Size / 10)))
					if LowerLipPosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreBasPosY_H0[Vertex] * (LowerLipPosY * Size / 10)))
					if LowerLipThickness > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreBasEpais_H1[Vertex] * (-LowerLipThickness * Size / 10)))
					if LowerLipThickness < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (LevreBasEpais_H0[Vertex] * (LowerLipThickness * Size / 10)))
					
					if EarsPosX > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosX_H1[Vertex] * (-EarsPosX * Size / 10)))
					if EarsPosX < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosX_H0[Vertex] * (EarsPosX * Size / 10)))
					if EarsPosY > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosY_H1[Vertex] * (-EarsPosY * Size / 10)))
					if EarsPosY < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosY_H0[Vertex] * (EarsPosY * Size / 10)))
					if EarsPosZ > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosZ_H1[Vertex] * (-EarsPosZ * Size / 10)))
					if EarsPosZ < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesPosZ_H0[Vertex] * (EarsPosZ * Size / 10)))
					
					if EarsSize > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesTaille_H1[Vertex] * (-EarsSize * Size / 10)))
					if EarsSize < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesTaille_H0[Vertex] * (EarsSize * Size / 10)))
					if EarsAngle > 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesAngle_H1[Vertex] * (-EarsAngle * Size / 10)))
					if EarsAngle < 0 do (For Vertex = 1 to 300 do MorphArray[Vertex] += (OreillesAngle_H0[Vertex] * (EarsAngle * Size / 10)))
				)
				1:--the roundness
				(
					--First : if morpharray and rondeurarray exist, I substract rondeurarray to morpharray in order to avoid to add rondeurarray more than once to morpharray
					--if roundness > 0 or if roundness < 0, rondeurarray is calculated and added to morpharray. That's why i MUST proceed to the substraction described sooner.
					--rondeur_H1 and Rondeur_H0 are the base morph array stored in FM_Data.dat. I multiply them by the value of the parameter to build rondeurarray. Rondeurarray is weighted, rondeur_Hx not
					--then, i add rondeurarray to morpharray. If roundness == 0, rondeurarray is emptied to free memory.
					--the 46 others conditions work the same way.
					if MorphArray[300] != undefined and RondeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= RondeurArray[Vertex]))
					if Roundness > 0 do
					(
						For Vertex = 1 to 300 do
						(
							RondeurArray[Vertex] = Rondeur_H1[Vertex] * (-Roundness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += RondeurArray[Vertex]
						)
					)
					if Roundness < 0 do
					(
						For Vertex = 1 to 300 do
						(
							RondeurArray[Vertex] = Rondeur_H0[Vertex] * (Roundness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += RondeurArray[Vertex]
						)
					)
					if Roundness == 0 do RondeurArray = #()
				)
				2:--the lenght
				(
					if MorphArray[300] != undefined and LongueurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LongueurArray[Vertex]))
					if Length > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LongueurArray[Vertex] = Longueur_H1[Vertex] * (-Length * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LongueurArray[Vertex]
						)
					)
					if Length < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LongueurArray[Vertex] = Longueur_H0[Vertex] * (Length * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LongueurArray[Vertex]
						)
					)
					if Length == 0 do LongueurArray = #()
				)
				3:--the width
				(
					if MorphArray[300] != undefined and LargeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LargeurArray[Vertex]))
					if Width > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LargeurArray[Vertex] = Largeur_H1[Vertex] * (-Width * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LargeurArray[Vertex]
						)
					)
					if Width < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LargeurArray[Vertex] = Largeur_H0[Vertex] * (Width * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LargeurArray[Vertex]
						)
					)
					if Width == 0 do LargeurArray = #()
				)
				4:--the forehead size
				(
					if MorphArray[300] != undefined and FrontTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= FrontTailleArray[Vertex]))
					if ForeHeadSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontTailleArray[Vertex] = FrontTaille_H1[Vertex] * (-ForeHeadSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontTailleArray[Vertex]
						)
					)
					if ForeHeadSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontTailleArray[Vertex] = FrontTaille_H0[Vertex] * (ForeHeadSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontTailleArray[Vertex]
						)
					)
					if ForeHeadSize == 0 do FrontTailleArray = #()
				)
				5:-- l angle du front
				(
					if MorphArray[300] != undefined and FrontAngleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= FrontAngleArray[Vertex]))
					if ForeHeadAngle > 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontAngleArray[Vertex] = FrontAngle_H1[Vertex] * (-ForeHeadAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontAngleArray[Vertex]
						)
					)
					if ForeHeadAngle < 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontAngleArray[Vertex] = FrontAngle_H0[Vertex] * (ForeHeadAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontAngleArray[Vertex]
						)
					)
					if ForeHeadAngle == 0 do FrontAngleArray = #()
				)
				6:-- la position y du front
				(
					if MorphArray[300] != undefined and FrontPosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= FrontPosYArray[Vertex]))
					if ForeHeadPosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontPosYArray[Vertex] = FrontPosY_H1[Vertex] * (-ForeHeadPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontPosYArray[Vertex]
						)
					)
					if ForeHeadPosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontPosYArray[Vertex] = FrontPosY_H0[Vertex] * (ForeHeadPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontPosYArray[Vertex]
						)
					)
					if ForeHeadPosY == 0 do FrontPosYArray = #()
				)
				7:-- la position z du front
				(
					if MorphArray[300] != undefined and FrontPosZArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= FrontPosZArray[Vertex]))
					if ForeHeadPosZ > 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontPosZArray[Vertex] = FrontPosZ_H1[Vertex] * (-ForeHeadPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontPosZArray[Vertex]
						)
					)
					if ForeHeadPosZ < 0 do
					(
						For Vertex = 1 to 300 do
						(
							FrontPosZArray[Vertex] = FrontPosZ_H0[Vertex] * (ForeHeadPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += FrontPosZArray[Vertex]
						)
					)
					if ForeHeadPosZ == 0 do FrontPosZArray = #()
				)
				8:-- l ossature des joues
				(
					if MorphArray[300] != undefined and JouesOsArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= JouesOsArray[Vertex]))
					if CheeksBone > 0 do
					(
						For Vertex = 1 to 300 do
						(
							JouesOsArray[Vertex] = JouesOs_H1[Vertex] * (-CheeksBone * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += JouesOsArray[Vertex]
						)
					)
					if CheeksBone < 0 do
					(
						For Vertex = 1 to 300 do
						(
							JouesOsArray[Vertex] = JouesOs_H0[Vertex] * (CheeksBone * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += JouesOsArray[Vertex]
						)
					)
					if CheeksBone == 0 do JouesOsArray = #()
				)
				9:-- la grosseur des joues
				(
					if MorphArray[300] != undefined and JouesGrosArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= JouesGrosArray[Vertex]))
					if CheeksFat > 0 do
					(
						For Vertex = 1 to 300 do
						(
							JouesGrosArray[Vertex] = JouesGros_H1[Vertex] * (-CheeksFat * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += JouesGrosArray[Vertex]
						)
					)
					if CheeksFat < 0 do
					(
						For Vertex = 1 to 300 do
						(
							JouesGrosArray[Vertex] = JouesGros_H0[Vertex] * (CheeksFat * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += JouesGrosArray[Vertex]
						)
					)
					if CheeksFat == 0 do JouesGrosArray = #()
				)
				10:--l angle de la machoire
				(
					if MorphArray[300] != undefined and MachAngleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= MachAngleArray[Vertex]))
					if JawAngle > 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachAngleArray[Vertex] = MachAngle_H1[Vertex] * (-JawAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachAngleArray[Vertex]
						)
					)
					if JawAngle < 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachAngleArray[Vertex] = MachAngle_H0[Vertex] * (JawAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachAngleArray[Vertex]
						)
					)
					if JawAngle == 0 do MachAngleArray = #()
				)
				11:-- la forme de la machoire
				(
					if MorphArray[300] != undefined and MachFormeArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= MachFormeArray[Vertex]))
					if JawShape > 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachFormeArray[Vertex] = MachForme_H1[Vertex] * (-JawShape * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachFormeArray[Vertex]
						)
					)
					if JawShape < 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachFormeArray[Vertex] = MachForme_H0[Vertex] * (JawShape * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachFormeArray[Vertex]
						)
					)
					if JawShape == 0 do MachFormeArray = #()
				)
				12:--la Size de la machoire
				(
					if MorphArray[300] != undefined and MachTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= MachTailleArray[Vertex]))
					if JawSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachTailleArray[Vertex] = MachTaille_H1[Vertex] * (-JawSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachTailleArray[Vertex]
						)
					)
					if JawSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							MachTailleArray[Vertex] = MachTaille_H0[Vertex] * (JawSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MachTailleArray[Vertex]
						)
					)
					if JawSize == 0 do MachTailleArray = #()
				)
				13:--la Size du menton
				(
					if MorphArray[300] != undefined and MentonTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= MentonTailleArray[Vertex]))
					if ChinSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							MentonTailleArray[Vertex] = MentonTaille_H1[Vertex] * (-ChinSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MentonTailleArray[Vertex]
						)
					)
					if ChinSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							MentonTailleArray[Vertex] = MentonTaille_H0[Vertex] * (ChinSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MentonTailleArray[Vertex]
						)
					)
					if ChinSize == 0 do MentonTailleArray = #()
				)
				14:-- la grosseur du menton
				(
					if MorphArray[300] != undefined and MentonGrosArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= MentonGrosArray[Vertex]))
					if ChinFat > 0 do
					(
						For Vertex = 1 to 300 do
						(
							MentonGrosArray[Vertex] = MentonGros_H1[Vertex] * (-ChinFat * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MentonGrosArray[Vertex]
						)
					)
					if ChinFat < 0 do
					(
						For Vertex = 1 to 300 do
						(
							MentonGrosArray[Vertex] = MentonGros_H0[Vertex] * (ChinFat * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += MentonGrosArray[Vertex]
						)
					)
					if ChinFat == 0 do MentonGrosArray = #()
				)
				15:--le double menton
				(
					if MorphArray[300] != undefined and DoubleMentonArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= DoubleMentonArray[Vertex]))
					if DoubleChin > 0 do
					(
						For Vertex = 1 to 300 do
						(
							DoubleMentonArray[Vertex] = DoubleMenton_H1[Vertex] * (-DoubleChin * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += DoubleMentonArray[Vertex]
						)
					)
					if DoubleChin < 0 do
					(
						For Vertex = 1 to 300 do
						(
							DoubleMentonArray[Vertex] = DoubleMenton_H0[Vertex] * (DoubleChin * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += DoubleMentonArray[Vertex]
						)
					)
					if DoubleChin == 0 do DoubleMentonArray = #()
				)
				16:--la Size de la nuque
				(
					if MorphArray[300] != undefined and NuqueTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NuqueTailleArray[Vertex]))
					if NeckSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NuqueTailleArray[Vertex] = NuqueTaille_H1[Vertex] * (-NeckSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NuqueTailleArray[Vertex]
						)
					)
					if NeckSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NuqueTailleArray[Vertex] = NuqueTaille_H0[Vertex] * (NeckSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NuqueTailleArray[Vertex]
						)
					)
					if NeckSize == 0 do NuqueTailleArray = #()
				)
				17:--la musculature de la nuque
				(
					if MorphArray[300] != undefined and NuqueMusArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NuqueMusArray[Vertex]))
					if NeckMuscles > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NuqueMusArray[Vertex] = NuqueMus_H1[Vertex] * (-NeckMuscles * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NuqueMusArray[Vertex]
						)
					)
					if NeckMuscles < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NuqueMusArray[Vertex] = NuqueMus_H0[Vertex] * (NeckMuscles * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NuqueMusArray[Vertex]
						)
					)
					if NeckMuscles == 0 do NuqueMusArray = #()
				)
				18:
				(
					if MorphArray[300] != undefined and YeuxPosXArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= YeuxPosXArray[Vertex]))
					if EyesPosX > 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxPosXArray[Vertex] = YeuxPosX_H1[Vertex] * (-EyesPosX * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxPosXArray[Vertex]
						)
					)
					if EyesPosX < 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxPosXArray[Vertex] = YeuxPosX_H0[Vertex] * (EyesPosX * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxPosXArray[Vertex]
						)
					)
					if EyesPosX == 0 do YeuxPosXArray = #()
				)
				19:
				(
					if MorphArray[300] != undefined and YeuxTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= YeuxTailleArray[Vertex]))
					if EyesSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxTailleArray[Vertex] = YeuxTaille_H1[Vertex] * (-EyesSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxTailleArray[Vertex]
						)
					)
					if EyesSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxTailleArray[Vertex] = YeuxTaille_H0[Vertex] * (EyesSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxTailleArray[Vertex]
						)
					)
					if EyesSize == 0 do YeuxTailleArray = #()
				)
				20:
				(
					if MorphArray[300] != undefined and CernesGaucheArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= CernesGaucheArray[Vertex]))
					if BulgeLeftEye > 0 do
					(
						For Vertex = 1 to 300 do
						(
							CernesGaucheArray[Vertex] = CernesGauche_H1[Vertex] * (-BulgeLeftEye * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += CernesGaucheArray[Vertex]
						)
					)
					if BulgeLeftEye < 0 do
					(
						For Vertex = 1 to 300 do
						(
							CernesGaucheArray[Vertex] = CernesGauche_H0[Vertex] * (BulgeLeftEye * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += CernesGaucheArray[Vertex]
						)
					)
					if BulgeLeftEye == 0 do CernesGaucheArray = #()
				)
				21:
				(
					if MorphArray[300] != undefined and CernesDroiteArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= CernesDroiteArray[Vertex]))
					if BulgeRightEye > 0 do
					(
						For Vertex = 1 to 300 do
						(
							CernesDroiteArray[Vertex] = CernesDroite_H1[Vertex] * (-BulgeRightEye * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += CernesDroiteArray[Vertex]
						)
					)
					if BulgeRightEye < 0 do
					(
						For Vertex = 1 to 300 do
						(
							CernesDroiteArray[Vertex] = CernesDroite_H0[Vertex] * (BulgeRightEye * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += CernesDroiteArray[Vertex]
						)
					)
					if BulgeRightEye == 0 do CernesDroiteArray = #()
				)
				22:
				(
					if MorphArray[300] != undefined and YeuxCoinsArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= YeuxCoinsArray[Vertex]))
					if EyesCorners > 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxCoinsArray[Vertex] = YeuxCoins_H1[Vertex] * (-EyesCorners * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxCoinsArray[Vertex]
						)
					)
					if EyesCorners < 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxCoinsArray[Vertex] = YeuxCoins_H0[Vertex] * (EyesCorners * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxCoinsArray[Vertex]
						)
					)
					if EyesCorners == 0 do YeuxCoinsArray = #()
				)
				23:
				(
					if MorphArray[300] != undefined and YeuxFronceArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= YeuxFronceArray[Vertex]))
					if EyesSquarness > 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxFronceArray[Vertex] = YeuxFronce_H1[Vertex] * (-EyesSquarness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxFronceArray[Vertex]
						)
					)
					if EyesSquarness < 0 do
					(
						For Vertex = 1 to 300 do
						(
							YeuxFronceArray[Vertex] = YeuxFronce_H0[Vertex] * (EyesSquarness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += YeuxFronceArray[Vertex]
						)
					)
					if EyesSquarness == 0 do YeuxFronceArray = #()
				)
				24:
				(
					if MorphArray[300] != undefined and PaupiereArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= PaupiereArray[Vertex]))
					if EyeLid > 0 do
					(
						For Vertex = 1 to 300 do
						(
							PaupiereArray[Vertex] = Paupiere_H1[Vertex] * (-EyeLid * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += PaupiereArray[Vertex]
						)
					)
					if EyeLid < 0 do
					(
						For Vertex = 1 to 300 do
						(
							PaupiereArray[Vertex] = Paupiere_H0[Vertex] * (EyeLid * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += PaupiereArray[Vertex]
						)
					)
					if EyeLid == 0 do PaupiereArray = #()
				)
				25:
				(
					if MorphArray[300] != undefined and NezPosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezPosYArray[Vertex]))
					if NosePosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezPosYArray[Vertex] = NezPosY_H1[Vertex] * (-NosePosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezPosYArray[Vertex]
						)
					)
					if NosePosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezPosYArray[Vertex] = NezPosY_H0[Vertex] * (NosePosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezPosYArray[Vertex]
						)
					)
					if NosePosY == 0 do NezPosYArray = #()
				)
				26:
				(
					if MorphArray[300] != undefined and NezPosZArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezPosZArray[Vertex]))
					if NosePosZ > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezPosZArray[Vertex] = NezPosZ_H1[Vertex] * (-NosePosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezPosZArray[Vertex]
						)
					)
					if NosePosZ < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezPosZArray[Vertex] = NezPosZ_H0[Vertex] * (NosePosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezPosZArray[Vertex]
						)
					)
					if NosePosZ == 0 do NezPosZArray = #()
				)
				27:
				(
					if MorphArray[300] != undefined and NezAreteArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezAreteArray[Vertex]))
					if NoseEdge > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezAreteArray[Vertex] = NezArete_H1[Vertex] * (-NoseEdge * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezAreteArray[Vertex]
						)
					)
					if NoseEdge < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezAreteArray[Vertex] = NezArete_H0[Vertex] * (NoseEdge * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezAreteArray[Vertex]
						)
					)
					if NoseEdge == 0 do NezAreteArray = #()
				)
				28:
				(
					if MorphArray[300] != undefined and NezBosseArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezBosseArray[Vertex]))
					if NoseBump > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezBosseArray[Vertex] = NezBosse_H1[Vertex] * (-NoseBump * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezBosseArray[Vertex]
						)
					)
					if NoseBump < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezBosseArray[Vertex] = NezBosse_H0[Vertex] * (NoseBump * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezBosseArray[Vertex]
						)
					)
					if NoseBump == 0 do NezBosseArray = #()
				)
				29:
				(
					if MorphArray[300] != undefined and NezAngleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezAngleArray[Vertex]))
					if NoseAngle > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezAngleArray[Vertex] = NezAngle_H1[Vertex] * (-NoseAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezAngleArray[Vertex]
						)
					)
					if NoseAngle < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezAngleArray[Vertex] = NezAngle_H0[Vertex] * (NoseAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezAngleArray[Vertex]
						)
					)
					if NoseAngle == 0 do NezAngleArray = #()
				)
				30:
				(
					if MorphArray[300] != undefined and NezLargeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezLargeurArray[Vertex]))
					if NoseWidth > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezLargeurArray[Vertex] = NezLargeur_H1[Vertex] * (-NoseWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezLargeurArray[Vertex]
						)
					)
					if NoseWidth < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezLargeurArray[Vertex] = NezLargeur_H0[Vertex] * (NoseWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezLargeurArray[Vertex]
						)
					)
					if NoseWidth == 0 do NezLargeurArray = #()
				)
				31:
				(
					if MorphArray[300] != undefined and NezExTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezExTailleArray[Vertex]))
					if NoseTipSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExTailleArray[Vertex] = NezExTaille_H1[Vertex] * (-NoseTipSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExTailleArray[Vertex]
						)
					)
					if NoseTipSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExTailleArray[Vertex] = NezExTaille_H0[Vertex] * (NoseTipSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExTailleArray[Vertex]
						)
					)
					if NoseTipSize == 0 do NezExTailleArray = #()
				)
				32:
				(
					if MorphArray[300] != undefined and NezExHauteurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezExHauteurArray[Vertex]))
					if NoseTipHeight > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExHauteurArray[Vertex] = NezExHauteur_H1[Vertex] * (-NoseTipHeight * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExHauteurArray[Vertex]
						)
					)
					if NoseTipHeight < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExHauteurArray[Vertex] = NezExHauteur_H0[Vertex] * (NoseTipHeight * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExHauteurArray[Vertex]
						)
					)
					if NoseTipHeight == 0 do NezExHauteurArray = #()
				)
				33:
				(
					if MorphArray[300] != undefined and NezExLargeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NezExLargeurArray[Vertex]))
					if NoseTipWidth > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExLargeurArray[Vertex] = NezExLargeur_H1[Vertex] * (-NoseTipWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExLargeurArray[Vertex]
						)
					)
					if NoseTipWidth < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NezExLargeurArray[Vertex] = NezExLargeur_H0[Vertex] * (NoseTipWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NezExLargeurArray[Vertex]
						)
					)
					if NoseTipWidth == 0 do NezExLargeurArray = #()
				)
				34:
				(
					if MorphArray[300] != undefined and NarinesLargeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NarinesLargeurArray[Vertex]))
					if NostrilsWidth > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NarinesLargeurArray[Vertex] = NarinesLargeur_H1[Vertex] * (-NostrilsWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NarinesLargeurArray[Vertex]
						)
					)
					if NostrilsWidth < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NarinesLargeurArray[Vertex] = NarinesLargeur_H0[Vertex] * (NostrilsWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NarinesLargeurArray[Vertex]
						)
					)
					if NostrilsWidth == 0 do NarinesLargeurArray = #()
				)
				35:
				(
					if MorphArray[300] != undefined and NarinesHauteurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= NarinesHauteurArray[Vertex]))
					if NostrilsHeight > 0 do
					(
						For Vertex = 1 to 300 do
						(
							NarinesHauteurArray[Vertex] = NarinesHauteur_H1[Vertex] * (-NostrilsHeight * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NarinesHauteurArray[Vertex]
						)
					)
					if NostrilsHeight < 0 do
					(
						For Vertex = 1 to 300 do
						(
							NarinesHauteurArray[Vertex] = NarinesHauteur_H0[Vertex] * (NostrilsHeight * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += NarinesHauteurArray[Vertex]
						)
					)
					if NostrilsHeight == 0 do NarinesHauteurArray = #()
				)
				36:
				(
					if MorphArray[300] != undefined and BoucheLargeurArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= BoucheLargeurArray[Vertex]))
					if MouthWidth > 0 do
					(
						For Vertex = 1 to 300 do
						(
							BoucheLargeurArray[Vertex] = BoucheLargeur_H1[Vertex] * (-MouthWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BoucheLargeurArray[Vertex]
						)
					)
					if MouthWidth < 0 do
					(
						For Vertex = 1 to 300 do
						(
							BoucheLargeurArray[Vertex] = BoucheLargeur_H0[Vertex] * (MouthWidth * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BoucheLargeurArray[Vertex]
						)
					)
					if MouthWidth == 0 do BoucheLargeurArray = #()
				)
				37:
				(
					if MorphArray[300] != undefined and BouchePosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= BouchePosYArray[Vertex]))
					if MouthPosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							BouchePosYArray[Vertex] = BouchePosY_H1[Vertex] * (-MouthPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BouchePosYArray[Vertex]
						)
					)
					if MouthPosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							BouchePosYArray[Vertex] = BouchePosY_H0[Vertex] * (MouthPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BouchePosYArray[Vertex]
						)
					)
					if MouthPosY == 0 do BouchePosYArray = #()
				)
				38:
				(
					if MorphArray[300] != undefined and BouchePosZArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= BouchePosZArray[Vertex]))
					if MouthPosZ > 0 do
					(
						For Vertex = 1 to 300 do
						(
							BouchePosZArray[Vertex] = BouchePosZ_H1[Vertex] * (-MouthPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BouchePosZArray[Vertex]
						)
					)
					if MouthPosZ < 0 do
					(
						For Vertex = 1 to 300 do
						(
							BouchePosZArray[Vertex] = BouchePosZ_H0[Vertex] * (MouthPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += BouchePosZArray[Vertex]
						)
					)
					if MouthPosZ == 0 do BouchePosZArray = #()
				)
				39:
				(
					if MorphArray[300] != undefined and LevreHautPosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LevreHautPosYArray[Vertex]))
					if UpperLipPosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreHautPosYArray[Vertex] = LevreHautPosY_H1[Vertex] * (-UpperLipPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreHautPosYArray[Vertex]
						)
					)
					if UpperLipPosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreHautPosYArray[Vertex] = LevreHautPosY_H0[Vertex] * (UpperLipPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreHautPosYArray[Vertex]
						)
					)
					if UpperLipPosY == 0 do LevreHautPosYArray = #()
				)
				40:
				(
					if MorphArray[300] != undefined and LevreHautEpaisArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LevreHautEpaisArray[Vertex]))
					if UpperLipThickness > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreHautEpaisArray[Vertex] = LevreHautEpais_H1[Vertex] * (-UpperLipThickness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreHautEpaisArray[Vertex]
						)
					)
					if UpperLipThickness < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreHautEpaisArray[Vertex] = LevreHautEpais_H0[Vertex] * (UpperLipThickness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreHautEpaisArray[Vertex]
						)
					)
					if UpperLipThickness == 0 do LevreHautEpaisArray = #()
				)
				41:
				(
					if MorphArray[300] != undefined and LevreBasPosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LevreBasPosYArray[Vertex]))
					if LowerLipPosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreBasPosYArray[Vertex] = LevreBasPosY_H1[Vertex] * (-LowerLipPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreBasPosYArray[Vertex]
						)
					)
					if LowerLipPosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreBasPosYArray[Vertex] = LevreBasPosY_H0[Vertex] * (LowerLipPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreBasPosYArray[Vertex]
						)
					)
					if LowerLipPosY == 0 do LevreBasPosYArray = #()
				)
				42:
				(
					if MorphArray[300] != undefined and LevreBasEpaisArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= LevreBasEpaisArray[Vertex]))
					if LowerLipThickness > 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreBasEpaisArray[Vertex] = LevreBasEpais_H1[Vertex] * (-LowerLipThickness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreBasEpaisArray[Vertex]
						)
					)
					if LowerLipThickness < 0 do
					(
						For Vertex = 1 to 300 do
						(
							LevreBasEpaisArray[Vertex] = LevreBasEpais_H0[Vertex] * (LowerLipThickness * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += LevreBasEpaisArray[Vertex]
						)
					)
					if LowerLipThickness == 0 do LevreBasEpaisArray = #()
				)
				43:
				(
					if MorphArray[300] != undefined and OreillesPosXArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= OreillesPosXArray[Vertex]))
					if EarsPosX > 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosXArray[Vertex] = OreillesPosX_H1[Vertex] * (-EarsPosX * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosXArray[Vertex]
						)
					)
					if EarsPosX < 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosXArray[Vertex] = OreillesPosX_H0[Vertex] * (EarsPosX * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosXArray[Vertex]
						)
					)
					if EarsPosX == 0 do OreillesPosXArray = #()
				)
				44:
				(
					if MorphArray[300] != undefined and OreillesPosYArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= OreillesPosYArray[Vertex]))
					if EarsPosY > 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosYArray[Vertex] = OreillesPosY_H1[Vertex] * (-EarsPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosYArray[Vertex]
						)
					)
					if EarsPosY < 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosYArray[Vertex] = OreillesPosY_H0[Vertex] * (EarsPosY * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosYArray[Vertex]
						)
					)
					if EarsPosY == 0 do OreillesPosYArray = #()
				)
				45:
				(
					if MorphArray[300] != undefined and OreillesPosZArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= OreillesPosZArray[Vertex]))
					if EarsPosZ > 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosZArray[Vertex] = OreillesPosZ_H1[Vertex] * (-EarsPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosZArray[Vertex]
						)
					)
					if EarsPosZ < 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesPosZArray[Vertex] = OreillesPosZ_H0[Vertex] * (EarsPosZ * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesPosZArray[Vertex]
						)
					)
					if EarsPosZ == 0 do OreillesPosZArray = #()
				)
				46:
				(
					if MorphArray[300] != undefined and OreillesTailleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= OreillesTailleArray[Vertex]))
					if EarsSize > 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesTailleArray[Vertex] = OreillesTaille_H1[Vertex] * (-EarsSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesTailleArray[Vertex]
						)
					)
					if EarsSize < 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesTailleArray[Vertex] = OreillesTaille_H0[Vertex] * (EarsSize * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesTailleArray[Vertex]
						)
					)
					if EarsSize == 0 do OreillesTailleArray = #()
				)
				47:
				(
					if MorphArray[300] != undefined and OreillesAngleArray[300] != undefined do (For Vertex = 1 to 300 do (Morpharray[vertex] -= OreillesAngleArray[Vertex]))
					if EarsAngle > 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesAngleArray[Vertex] = OreillesAngle_H1[Vertex] * (-EarsAngle * Size / 10)
							if MorphArray[Vertex] == undefined do 
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesAngleArray[Vertex]
						)
					)
					if EarsAngle < 0 do
					(
						For Vertex = 1 to 300 do
						(
							OreillesAngleArray[Vertex] = OreillesAngle_H0[Vertex] * (EarsAngle * Size / 10)
							if MorphArray[Vertex] == undefined do
							(
								MorphArray[Vertex] = [0,0,0]
							)
							MorphArray[vertex] += OreillesAngleArray[Vertex]
						)
					)
					if EarsAngle == 0 do OreillesAngleArray = #()
				)
			)-- END CASE
			
--************************************************************************************************************************
			if MorphArray[300] != undefined do (for Vertex = 1 to 300 do (Meshop.MoveVert mesh Vertex MorphArray[Vertex])) -- it s here I move the vertices depending on morpharray
--************************************************************************************************************************

			--iscopy is tested here. Without this set of methods, when face_maker is copied, all arrays are emptied by max. But the real topology stays the same as the copied object
			--that s why i must rebuild all arrays in order to make the script run properly
			If IsCopy == True do
			(
				Local TempTaille = This.GenRll.Controls[4].Value --i retrieve the size value in the UI
				Local ControlsArray = #() --controlsarray stores the UIcontrols values
				-- the loops below store the spinner values in controlsarray (the spinners has no caption)
				For UIitems = 1 to This.TeteHautRll.Controls.count do
				(
					if This.TeteHautRll.Controls[UIitems].caption == "" do (append ControlsArray This.TeteHautRll.controls[UIitems].value)
				)
				For UIitems = 1 to This.TeteBasRll.Controls.count do
				(
					if This.TeteBasRll.Controls[UIitems].caption == "" do (append ControlsArray This.TeteBasRll.controls[UIitems].value)
				)
				For UIitems = 1 to This.YeuxRll.Controls.count do
				(
					if This.YeuxRll.Controls[UIitems].caption == "" do (append ControlsArray This.YeuxRll.controls[UIitems].value)
				)
				For UIitems = 1 to This.NezRll.Controls.count do
				(
					if This.NezRll.Controls[UIitems].caption == "" do (append ControlsArray This.NezRll.controls[UIitems].value)
				)
				For UIitems = 1 to This.BoucheRll.Controls.count do
				(
					if This.BoucheRll.Controls[UIitems].caption == "" do (append ControlsArray This.BoucheRll.controls[UIitems].value)
				)
				For UIitems = 1 to This.OreilleRll.Controls.count do
				(
					if This.OreilleRll.Controls[UIitems].caption == "" do (append ControlsArray This.OreilleRll.controls[UIitems].value)
				)
				--then, i can start building arrays
				For Vertex = 1 to 300 do
				(
					--depending on gender, morpharray is necessary the substraction between the real vertices position and the vertices position when no targets are applied (so vertarray_x)
					If This.GenRll.Controls[2].state == 1 then (MorphArray[Vertex] = (GetVert mesh Vertex) - (VertArray_H[Vertex] * TempTaille / 10)) else (MorphArray[Vertex] =  (GetVert mesh Vertex) - (VertArray_F[Vertex] * TempTaille / 10))
					--then, each array is rebuild by multiplying the base morph target (stored in fm_data.dat) by the value of the UI items corresponding stored in controlsarray.
					--I scale the arrays with temptaille (the size stored in the UI size spinner) and i divide by 10 because it is a convention since the beginning.
					--I repeat this process for the remaining 46 arrays
					If ControlsArray[1] > 0 do (RondeurArray[Vertex] = Rondeur_H1[Vertex] * (-ControlsArray[1]) * TempTaille / 10)
					if ControlsArray[1] < 0 do (RondeurArray[Vertex] = Rondeur_H0[Vertex] * ControlsArray[1] * TempTaille / 10)
					
					If ControlsArray[2] > 0 do (LongueurArray[Vertex] = Longueur_H1[Vertex] * (-ControlsArray[2]) * TempTaille / 10)
					if ControlsArray[2] < 0 do (LongueurArray[Vertex] = Longueur_H0[Vertex] * ControlsArray[2] * TempTaille / 10)
					If ControlsArray[3] > 0 do (LargeurArray[Vertex] = Largeur_H1[Vertex] * (-ControlsArray[3]) * TempTaille / 10)
					if ControlsArray[3] < 0 do (LargeurArray[Vertex] = Largeur_H0[Vertex] * (ControlsArray[3]) * TempTaille / 10)
					
					If ControlsArray[4] > 0 do (FrontTailleArray[Vertex] = FrontTaille_H1[Vertex] * (-ControlsArray[4]) * TempTaille / 10)
					if ControlsArray[4] < 0 do (FrontTailleArray[Vertex] = FrontTaille_H0[Vertex] * ControlsArray[4] * TempTaille / 10)
					If ControlsArray[5] > 0 do (FrontAngleArray[Vertex] = FrontAngle_H1[Vertex] * (-ControlsArray[5]) * TempTaille / 10)
					if ControlsArray[5] < 0 do (FrontAngleArray[Vertex] = FrontAngle_H0[Vertex] * ControlsArray[5] * TempTaille / 10)
					If ControlsArray[6] > 0 do (FrontPosYArray[Vertex] = FrontPosY_H1[Vertex] * (-ControlsArray[6]) * TempTaille / 10)
					if ControlsArray[6] < 0 do (FrontPosYArray[Vertex] = FrontPosY_H0[Vertex] * ControlsArray[6] * TempTaille / 10)
					If ControlsArray[7] > 0 do (FrontPosZArray[Vertex] = FrontPosZ_H1[Vertex] * (-ControlsArray[7]) * TempTaille / 10)
					if ControlsArray[7] < 0 do (FrontPosZArray[Vertex] = FrontPosZ_H0[Vertex] * ControlsArray[7] * TempTaille / 10)
					
					If ControlsArray[8] > 0 do (JouesOsArray[Vertex] = JouesOs_H1[Vertex] * (-ControlsArray[8]) * TempTaille / 10)
					if ControlsArray[8] < 0 do (JouesOsArray[Vertex] = JouesOs_H0[Vertex] * ControlsArray[8] * TempTaille / 10)
					If ControlsArray[9] > 0 do (JouesGrosArray[Vertex] = JouesGros_H1[Vertex] * (-ControlsArray[9]) * TempTaille / 10)
					if ControlsArray[9] < 0 do (JouesGrosArray[Vertex] = JouesGros_H0[Vertex] * ControlsArray[9] * TempTaille / 10)
					
					If ControlsArray[10] > 0 do (MachAngleArray[Vertex] = MachAngle_H1[Vertex] * (-ControlsArray[10]) * TempTaille / 10)
					if ControlsArray[10] < 0 do (MachAngleArray[Vertex] = MachAngle_H0[Vertex] * ControlsArray[10] * TempTaille / 10)
					If ControlsArray[11] > 0 do (MachFormeArray[Vertex] = MachForme_H1[Vertex] * (-ControlsArray[11]) * TempTaille / 10)
					if ControlsArray[11] < 0 do (MachFormeArray[Vertex] = MachForme_H0[Vertex] * ControlsArray[11] * TempTaille / 10)
					If ControlsArray[12] > 0 do (MachTailleArray[Vertex] = MachTaille_H1[Vertex] * (-ControlsArray[12]) * TempTaille / 10)
					if ControlsArray[12] < 0 do (MachTailleArray[Vertex] = MachTaille_H0[Vertex] * ControlsArray[12] * TempTaille / 10)
					
					If ControlsArray[13] > 0 do (MentonTailleArray[Vertex] = MentonTaille_H1[Vertex] * (-ControlsArray[13]) * TempTaille / 10)
					if ControlsArray[13] < 0 do (MentonTailleArray[Vertex] = MentonTaille_H0[Vertex] * ControlsArray[13] * TempTaille / 10)
					If ControlsArray[14] > 0 do (MentonGrosArray[Vertex] = MentonGros_H1[Vertex] * (-ControlsArray[14]) * TempTaille / 10)
					if ControlsArray[14] < 0 do (MentonGrosArray[Vertex] = MentonGros_H0[Vertex] * ControlsArray[14] * TempTaille / 10)
					If ControlsArray[15] > 0 do (DoubleMentonArray[Vertex] = DoubleMenton_H1[Vertex] * (-ControlsArray[15]) * TempTaille / 10)
					if ControlsArray[15] < 0 do (DoubleMentonArray[Vertex] = DoubleMenton_H0[Vertex] * ControlsArray[15] * TempTaille / 10)
					
					If ControlsArray[16] > 0 do (NuqueTailleArray[Vertex] = NuqueTaille_H1[Vertex] * (-ControlsArray[16]) * TempTaille / 10)
					if ControlsArray[16] < 0 do (NuqueTailleArray[Vertex] = NuqueTaille_H0[Vertex] * ControlsArray[16] * TempTaille / 10)
					If ControlsArray[17] > 0 do (NuqueMusArray[Vertex] = NuqueMus_H1[Vertex] * (-ControlsArray[17]) * TempTaille / 10)
					if ControlsArray[17] < 0 do (NuqueMusArray[Vertex] = NuqueMus_H0[Vertex] * ControlsArray[17] * TempTaille / 10)
					
					If ControlsArray[18] > 0 do (YeuxPosXArray[Vertex] = YeuxPosX_H1[Vertex] * (-ControlsArray[18]) * TempTaille / 10)
					if ControlsArray[18] < 0 do (YeuxPosXArray[Vertex] = YeuxPosX_H0[Vertex] * ControlsArray[18] * TempTaille / 10)
					If ControlsArray[19] > 0 do (YeuxTailleArray[Vertex] = YeuxTaille_H1[Vertex] * (-ControlsArray[19]) * TempTaille / 10)
					if ControlsArray[19] < 0 do (YeuxTailleArray[Vertex] = YeuxTaille_H0[Vertex] * ControlsArray[19] * TempTaille / 10)
					
					If ControlsArray[20] > 0 do (CernesGaucheArray[Vertex] = CernesGauche_H1[Vertex] * (-ControlsArray[20]) * TempTaille / 10)
					if ControlsArray[20] < 0 do (CernesGaucheArray[Vertex] = CernesGauche_H0[Vertex] * ControlsArray[20] * TempTaille / 10)
					If ControlsArray[21] > 0 do (CernesDroiteArray[Vertex] = CernesDroite_H1[Vertex] * (-ControlsArray[21]) * TempTaille / 10)
					if ControlsArray[21] < 0 do (CernesDroiteArray[Vertex] = CernesDroite_H0[Vertex] * ControlsArray[21] * TempTaille / 10)
					
					If ControlsArray[22] > 0 do (YeuxCoinsArray[Vertex] = YeuxCoins_H1[Vertex] * (-ControlsArray[22]) * TempTaille / 10)
					if ControlsArray[22] < 0 do (YeuxCoinsArray[Vertex] = YeuxCoins_H0[Vertex] * ControlsArray[22] * TempTaille / 10)
					If ControlsArray[23] > 0 do (YeuxFronceArray[Vertex] = YeuxFronce_H1[Vertex] * (-ControlsArray[23]) * TempTaille / 10)
					if ControlsArray[23] < 0 do (YeuxFronceArray[Vertex] = YeuxFronce_H0[Vertex] * ControlsArray[23] * TempTaille / 10)
					If ControlsArray[24] > 0 do (PaupiereArray[Vertex] = Paupiere_H1[Vertex] * (-ControlsArray[24]) * TempTaille / 10)
					if ControlsArray[24] < 0 do (PaupiereArray[Vertex] = Paupiere_H0[Vertex] * ControlsArray[24] * TempTaille / 10)
					
					If ControlsArray[25] > 0 do (NezPosYArray[Vertex] = NezPosY_H1[Vertex] * (-ControlsArray[25]) * TempTaille / 10)
					if ControlsArray[25] < 0 do (NezPosYArray[Vertex] = NezPosY_H0[Vertex] * ControlsArray[25] * TempTaille / 10)
					If ControlsArray[26] > 0 do (NezPosZArray[Vertex] = NezPosZ_H1[Vertex] * (-ControlsArray[26]) * TempTaille / 10)
					if ControlsArray[26] < 0 do (NezPosZArray[Vertex] = NezPosZ_H0[Vertex] * ControlsArray[26] * TempTaille / 10)
					
					If ControlsArray[27] > 0 do (NezAreteArray[Vertex] = NezArete_H1[Vertex] * (-ControlsArray[27]) * TempTaille / 10)
					if ControlsArray[27] < 0 do (NezAreteArray[Vertex] = NezArete_H0[Vertex] * ControlsArray[27] * TempTaille / 10)
					If ControlsArray[28] > 0 do (NezBosseArray[Vertex] = NezBosse_H1[Vertex] * (-ControlsArray[28]) * TempTaille / 10)
					if ControlsArray[28] < 0 do (NezBosseArray[Vertex] = NezBosse_H0[Vertex] * ControlsArray[28] * TempTaille / 10)
					If ControlsArray[29] > 0 do (NezAngleArray[Vertex] = NezAngle_H1[Vertex] * (-ControlsArray[29]) * TempTaille / 10)
					if ControlsArray[29] < 0 do (NezAngleArray[Vertex] = NezAngle_H0[Vertex] * ControlsArray[29] * TempTaille / 10)
					If ControlsArray[30] > 0 do (NezLargeurArray[Vertex] = NezLargeur_H1[Vertex] * (-ControlsArray[30]) * TempTaille / 10)
					if ControlsArray[30] < 0 do (NezLargeurArray[Vertex] = NezLargeur_H0[Vertex] * ControlsArray[30] * TempTaille / 10)
					
					If ControlsArray[31] > 0 do (NezExTailleArray[Vertex] = NezExTaille_H1[Vertex] * (-ControlsArray[31]) * TempTaille / 10)
					if ControlsArray[31] < 0 do (NezExTailleArray[Vertex] = NezExTaille_H0[Vertex] * ControlsArray[31] * TempTaille / 10)
					If ControlsArray[32] > 0 do (NezExHauteurArray[Vertex] = NezExHauteur_H1[Vertex] * (-ControlsArray[32]) * TempTaille / 10)
					if ControlsArray[32] < 0 do (NezExHauteurArray[Vertex] = NezExHauteur_H0[Vertex] * ControlsArray[32] * TempTaille / 10)
					If ControlsArray[33] > 0 do (NezExLargeurArray[Vertex] = NezExLargeur_H1[Vertex] * (-ControlsArray[33]) * TempTaille / 10)
					if ControlsArray[33] < 0 do (NezExLargeurArray[Vertex] = NezExLargeur_H0[Vertex] * ControlsArray[33] * TempTaille / 10)
					
					If ControlsArray[34] > 0 do (NarinesLargeurArray[Vertex] = NarinesLargeur_H1[Vertex] * (-ControlsArray[34]) * TempTaille / 10)
					if ControlsArray[34] < 0 do (NarinesLargeurArray[Vertex] = NarinesLargeur_H0[Vertex] * ControlsArray[34] * TempTaille / 10)
					If ControlsArray[35] > 0 do (NarinesHauteurArray[Vertex] = NarinesHauteur_H1[Vertex] * (-ControlsArray[35]) * TempTaille / 10)
					if ControlsArray[35] < 0 do (NarinesHauteurArray[Vertex] = NarinesHauteur_H0[Vertex] * ControlsArray[35] * TempTaille / 10)
					
					If ControlsArray[36] > 0 do (BoucheLargeurArray[Vertex] = BoucheLargeur_H1[Vertex] * (-ControlsArray[36]) * TempTaille / 10)
					if ControlsArray[36] < 0 do (BoucheLargeurArray[Vertex] = BoucheLargeur_H0[Vertex] * ControlsArray[36] * TempTaille / 10)
					If ControlsArray[37] > 0 do (BouchePosYArray[Vertex] = BouchePosY_H1[Vertex] * (-ControlsArray[37]) * TempTaille / 10)
					if ControlsArray[37] < 0 do (BouchePosYArray[Vertex] = BouchePosY_H0[Vertex] * ControlsArray[37] * TempTaille / 10)
					If ControlsArray[38] > 0 do (BouchePosZArray[Vertex] = BouchePosZ_H1[Vertex] * (-ControlsArray[38]) * TempTaille / 10)
					if ControlsArray[38] < 0 do (BouchePosZArray[Vertex] = BouchePosZ_H0[Vertex] * ControlsArray[38] * TempTaille / 10)
					
					If ControlsArray[39] > 0 do (LevreHautPosYArray[Vertex] = LevreHautPosY_H1[Vertex] * (-ControlsArray[39]) * TempTaille / 10)
					if ControlsArray[39] < 0 do (LevreHautPosYArray[Vertex] = LevreHautPosY_H0[Vertex] * ControlsArray[39] * TempTaille / 10)
					If ControlsArray[40] > 0 do (LevreHautEpaisArray[Vertex] = LevreHautEpais_H1[Vertex] * (-ControlsArray[40]) * TempTaille / 10)
					if ControlsArray[40] < 0 do (LevreHautEpaisArray[Vertex] = LevreHautEpais_H0[Vertex] * ControlsArray[40] * TempTaille / 10)
					
					If ControlsArray[41] > 0 do (LevreBasPosYArray[Vertex] = LevreBasPosY_H1[Vertex] * (-ControlsArray[41]) * TempTaille / 10)
					if ControlsArray[41] < 0 do (LevreBasPosYArray[Vertex] = LevreBasPosY_H0[Vertex] * ControlsArray[41] * TempTaille / 10)
					If ControlsArray[42] > 0 do (LevreBasEpaisArray[Vertex] = LevreBasEpais_H1[Vertex] * (-ControlsArray[42]) * TempTaille / 10)
					if ControlsArray[42] < 0 do (LevreBasEpaisArray[Vertex] = LevreBasEpais_H0[Vertex] * ControlsArray[42] * TempTaille / 10)
					
					If ControlsArray[43] > 0 do (OreillesPosXArray[Vertex] = OreillesPosX_H1[Vertex] * (-ControlsArray[43]) * TempTaille / 10)
					if ControlsArray[43] < 0 do (OreillesPosXArray[Vertex] = OreillesPosX_H0[Vertex] * ControlsArray[43] * TempTaille / 10)
					If ControlsArray[44] > 0 do (OreillesPosYArray[Vertex] = OreillesPosY_H1[Vertex] * (-ControlsArray[44]) * TempTaille / 10)
					if ControlsArray[44] < 0 do (OreillesPosYArray[Vertex] = OreillesPosY_H0[Vertex] * ControlsArray[44] * TempTaille / 10)
					If ControlsArray[45] > 0 do (OreillesPosZArray[Vertex] = OreillesPosZ_H1[Vertex] * (-ControlsArray[45]) * TempTaille / 10)
					if ControlsArray[45] < 0 do (OreillesPosZArray[Vertex] = OreillesPosZ_H0[Vertex] * ControlsArray[45] * TempTaille / 10)
					
					If ControlsArray[46] > 0 do (OreillesTailleArray[Vertex] = OreillesTaille_H1[Vertex] * (-ControlsArray[46]) * TempTaille / 10)
					if ControlsArray[46] < 0 do (OreillesTailleArray[Vertex] = OreillesTaille_H0[Vertex] * ControlsArray[46] * TempTaille / 10)
					If ControlsArray[47] > 0 do (OreillesAngleArray[Vertex] = OreillesAngle_H1[Vertex] * (-ControlsArray[47]) * TempTaille / 10)
					if ControlsArray[47] < 0 do (OreillesAngleArray[Vertex] = OreillesAngle_H0[Vertex] * ControlsArray[47] * TempTaille / 10)
				)
				OldTaille = Size -- I reset oldtaille because facteur was forgotten when copy happened
			)-- END IF ISCOPY
			
			OldTime = CurrentTime
		)-- END BUILDMESH
		
		tool Create
		(
			on mousePoint click do
			 	case click of
				(
					1: nodeTM.translation = gridPoint
					2: #stop
				)
			on mouseMove click do
				case click of
				(
					2: Size = distance nodeTM.pos gridPoint
				)
		)
		
--********************************************************************************************
--** GESTIONNAIRE D'EVENEMENTS SUR FACEMAKER **
--********************************************************************************************
		
		on SetGenUVW True do
		(
			BuildTvFaces mesh
			for i = 1 to tf_Array.count do SetTvFace mesh i tf_Array[i]
		)
	)--END PLUGIN
	
--********************************************************************************************
--** EOF **
--********************************************************************************************